//                                                     ## NB MODIFIED BY BB##
// Arduino Morse Library  MODIFIED BY BB 10 March 2016 to include variables '_brightness' and 'brightness' to control LED flash brightness
//Further BB mods 12Jan17 to enable use of RGB and W LEDs
// Written by Erik Linder SM0RVV and Mark VandeWettering K6HX
// Contact: sm0rvv at google mail
//
// Released 2011 under GPLv3
//
// Version 0.2
//
// Corrected Morse Code errors , Glen Popiel KW5GP
//
// Usage:
//         Morse <handle>(<outputpinR>, <outputpinG>, <outputpinB>, <outputpinW>,<speed>, <brightness>);  //to include LED pin colour & variable 'brightness'
//         <handle>.sendmsg (*str);
//         <handle>.send (*char);
//         <handle>.sendbrightness (byte, byte);
#include "Arduino.h"
#include "Morse.h"
  byte _pin;   // LED pin colour to use for Morse at any time
  byte _brightness;  //extra variable added by BB 
  byte _speed;	 // Speed in WPM
  byte _pinR;	// Red LED Pin to beep or toggle, original line
  byte _pinG;	// Green LED Pin to beep or toggle, extra variable added by BB 
 byte _pinB;	        // Blue LED Pin to beep or toggle, extra variable added by BB
 byte _pinW;	// White LED Pin to beep or toggle, extra variable added by BB
  byte _beep;	// 1 == beep to speaker, 0 == toggle pin high and low
  int _dashlen;	// Length of dash
  int _dotlen;	// Length of dot
const  byte _morsetab[] = {	// Those with value 1 has no morsecode - code is decimal - but converted to reverse binary to send
    117, //ASCII 33 !    // This table arranged in the specific order of ASCII decimal values
    82,  //ASCII 34 "   //  Eg Number zero '1' is Ascii 49 in decimal. take away 33 (see approx line 192) and it is 16th in the table  
    1,   //ASCII 35 #    // and the number in red is 62 decimal, or  00111110 in binary. 
    200, //ASCII 36 $   //A and a have decimal code red 6 in table, binary is 0000 0110 
    1,   //ASCII 37 %   // M and m have decimal code red 7 , binary is 0000 0111. so for 'm',
    34,  //ASCII 38 &   //  the red code in binary is read LSB first at aprx line 199 with code  "if (_p & 1)", where _p is 0000 0111
    94,  //ASCII 39 '   // and since true, a dash is sent. The _p value is divided by 2 at line  aprx 221 with     _p = _p / 2;
    45, //ASCII 40 (   //  which makes _p= 0000 0011. This value is ANDed with 1 again and result in another dash. When then _p is  
    109, //ASCII 41 )   // divided by 2 again the result is "1", and the process terminates as in aprx line 198,   while (_p != 1)  is now  false.
    1,   //ASCII 42 *     // So, when the value of the character is represented in binary, the left-most '1' is used to terminate the sending of that character.
    42,  //ASCII 43 +   
    115, //ASCII 44 ,   
    97,  //ASCII 45 -   
    106,  //ASCII 46 .  
    41,  //ASCII 47 /  
    63,  //ASCII 48 0
    62,  //ASCII 49 1
    60,  //ASCII 50 2
    56,  //ASCII 51 3
    48,  //ASCII 52 4
    32,  //ASCII 53 5
    33,  //ASCII 54 6
    35,  //ASCII 55 7
    39,  //ASCII 56 8
    47,  //ASCII 57 9
    71, //ASCII 58 :	
    85,  //ASCII 59 ;	
    1,   //ASCII 60 <
    49,  //ASCII 61 =
    1,   //ASCII 62 >
    76,  //ASCII 63 ?
    86,  //ASCII 64 @	
    6,   //ASCII 65 A
    17,  //ASCII 66 B
    21,  //ASCII 67 C
    9,   //ASCII 68 D
    2,   //ASCII 69 E
    20,  //ASCII 70 F
    11,  //ASCII 71 G
    16,  //ASCII 72 H
    4,   //ASCII 73 I
    30,  //ASCII 74 J
    13,  //ASCII 75 K
    18,  //ASCII 76 L
    7,   //ASCII 77 M
    5,   //ASCII 78 N
    15,  //ASCII 79 O
    22,  //ASCII 80 P
    27,  //ASCII 81 Q
    10,  //ASCII 82 R
    8,   //ASCII 83 S
    3,   //ASCII 84 T
    12,  //ASCII 85 U
    24,  //ASCII 86 V
    14,  //ASCII 87 W
    25,  //ASCII 88 X
    29,  //ASCII 89 Y
    19,  //ASCII 90 Z
    1,   //ASCII 91 [    
    64,   //ASCII 92 backslash    
    1,   //ASCII 93 ]   
    1,   //ASCII 94 ^
    108,  //ASCII 95 _    
    94,  //ASCII 96 `    
    6,   //ASCII 97 a
    17,  //ASCII 98 b
    21,  //ASCII 99 c
    9,   //ASCII 100 d
    2,   //ASCII 101 e
    20,  //ASCII 102 f
    11,  //ASCII 103 g
    16,  //ASCII 104 h
    4,   //ASCII 105 i
    30,  //ASCII 106 j
    13,  //ASCII 107 k
    18,  //ASCII 108 l
    7,   //ASCII 109 m
    5,   //ASCII 110 n
    15,  //ASCII 111 o
    22,  //ASCII 112 p
    27,  //ASCII 113 q
    10,  //ASCII 114 r
    8,   //ASCII 115 s
    3,   //ASCII 116 t
    12,  //ASCII 117 u
    24,  //ASCII 118 v
    14,  //ASCII 119 w
    25,  //ASCII 120 x
    29,  //ASCII 121 y
    19,   //ASCII 122 z
    1,   //ASCII 123 left brace
    1,   //ASCII 124 vertical bar
    1,   //ASCII 125 right brace
    1,   //ASCII 126 tilde
    };
  
Morse::Morse(byte pinR, byte pinG,  byte pinB,  byte pinW, byte speed, byte beep)  // modified by BB to add vars for GBW LEDS
{
  // Save values for later use

  _pinR = pinR;
  _pinG = pinG;  // added by BB to add vars for GBW LEDS
  _pinB = pinB;  // added by BB to add vars for GBW LEDS
  _pinW = pinW;  // added by BB to add vars for GBW LEDS
  _speed = speed;
  _beep = beep;

  // Calculate the length of dash and dot
  _dotlen = (1200/_speed);
  _dashlen =  (3*_dotlen);

  // Set the pin to output mode
// pinMode(_pin, OUTPUT); mod by BB, line not needed, O/P set in setup section of main prog
}

void Morse::dash()
{
  analogWrite(_pin,_brightness);               //analogWrite set by BB io digital
  delay(_dashlen);
  analogWrite(_pin, 0);                               //analogWrite set by BB io digital
  delay(_dotlen);
}

void Morse::dit()
{
  analogWrite(_pin,_brightness);               //analogWrite set by BB io digital
  delay(_dotlen);
  analogWrite(_pin, 0);                               //analogWrite set by BB io digital
  delay(_dotlen);
}

void Morse::bdash()
{
  analogWrite(_pin, HIGH);
  delay(_dashlen);
  analogWrite(_pin, LOW);
  delay(_dotlen);
}

void Morse::bdit()
{
  analogWrite(_pin, HIGH);
  delay(_dotlen);
  analogWrite(_pin, LOW);
  delay(_dotlen);
}

void Morse::send(char c)
{

  byte _i;
  byte _p;

  // Send space
  if (c == ' ') {
    delay(7*_dotlen) ;
    return ;
  }
  
  // Do a table lookup to get morse data
  else {
    _i = ((byte) c) - 33;
    _p = _morsetab[_i];

  }

  // Main algoritm for each morse sign
  while (_p != 1) {
    if (_p & 1)
      switch (_beep) {
	case 0:
	  dash();
	  break;
        case 1:
          bdash();
          break;
        default:
          break;
      }
    else
      switch (_beep) {
	case 0:
	  dit();
	  break;
        case 1:
          bdit();
          break;
        default:
          break;
      }
    _p = _p / 2;
  }
  // Letterspace
  delay(2*_dotlen);
}

void Morse::sendmsg(const char *str)   //BB added 'const' 26Jun16 to comply with new rule for char *
{
  while (*str) {
    send(*str++);

  }
}
void Morse::sendbrightness(byte pin, byte brightness)
{
_pin = pin; // added by BB so that pin to use is accompanied by its reqd brightness
_brightness = brightness;  
analogWrite(_pin,_brightness);               //analogWrite set by BB io digital
}



